package com.example.upsecuritydata.util;


import cn.hutool.core.util.StrUtil;
import org.apache.commons.codec.binary.Base64;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.zip.GZIPInputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

public class Decrypt {
    public static void main(String[] args) throws Exception {
        File file = new File("D:\\aaa\\GXGH-basic_registered-1682072666671-all.bin");
        long fileSize = file.length();
        FileInputStream fi = new FileInputStream(file);
        byte[] dataArray = new byte[(int) fileSize];
        int offset = 0;
        int numRead = 0;
        while (offset < dataArray.length
                && (numRead = fi.read(dataArray, offset, dataArray.length - offset)) >= 0) {
            offset += numRead;
        }
        fi.close();
        // 确保所有数据均被读取
        if (offset != dataArray.length) {
            throw new RuntimeException("Could not completely read file "
                    + file.getName());
        }

        // 解密
        dataArray = decryptAlgorithm("1", dataArray, "1234567890abcDEF",
                "1234567890abcDEF");
        String xmlInfo = unZipCompression("1", dataArray);
        // xmlInfo为解密后内容
        System.out.println(xmlInfo);
    }

    public static List<File> getFiles(File[] files) {
        List<File> list = new ArrayList<File>();
        for (File file : files) {
            if (file.isFile() && file.getName().endsWith(".txt")
                    && !file.getName().endsWith("-0.txt")) {

                list.add(file);
            } else if (file.isDirectory()) {
                list.addAll(getFiles(file.listFiles()));
            }
        }
        return list;
    }

    // 解密
    public static void decrypt(File file, String aesKey, String aesOffset)
            throws Exception {
        BufferedReader br = new BufferedReader(new InputStreamReader(
                new FileInputStream(file)));
        StringBuilder sb = new StringBuilder();
        String line = null;
        while ((line = br.readLine()) != null) {
            sb.append(line);
        }
        br.close();
        String dataUpload = sb.toString();
        byte[] dataArray = getByteByBaseString(dataUpload);
        dataArray = decryptAlgorithm("1", dataArray, aesKey, aesOffset);
        String xmlInfo = unZipCompression("1", dataArray);
        File file1 = new File(file.getAbsolutePath().substring(0,
                file.getAbsolutePath().lastIndexOf("."))
                + "-0.txt");
        FileWriter fw = new FileWriter(file1);
        fw.write(xmlInfo);
        fw.close();
    }

    /**
     * BASE64解码
     *
     * @param str
     * @return
     */
    public static byte[] getByteByBaseString(String str) {
        byte[] bArray = null;
        try {
            bArray = str.getBytes("utf-8");
            if (Base64.isArrayByteBase64(bArray)) {
                bArray = Base64.decodeBase64(bArray);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return bArray;
    }

    /**
     * 对称解密
     *
     * @param encryptType 加密类型
     * @param basexml     指令文件压缩后的结果
     * @param aesKey      AES加密钥匙
     * @param aesOffsets  AES加密偏移量
     * @return
     */
    public static byte[] decryptAlgorithm(String encryptType, byte[] basexml,
                                          String aesKey, String aesOffsets) throws Exception {
        byte[] command = null;

        if (encryptType != null && encryptType.equals("0")) { // 不加密
            command = basexml;
        } else { // AES加密算法
            command = decrypt(basexml, aesKey, aesOffsets);
        }
        return command;
    }

    /**
     * 对AES算法加密的数据解密
     *
     * @param cipherText 要解密的字节数组
     * @param aeskey     密钥
     * @return 解密后的字节数组
     */
    public static byte[] decrypt(byte[] cipherText, String aeskey,
                                 String aesOffsets) throws Exception {
        byte[] aesBytes = aeskey.getBytes("utf-8");
        if (aeskey.length() > 16) {
            aesBytes = parseHexStr2Byte(aeskey);

        }
        SecretKeySpec skeySpec = new SecretKeySpec(aesBytes, "AES");
        Cipher cipher = null;
        if (aesOffsets != null && !(aesOffsets.trim()).equals("")) {
            cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            byte[] bytes = aesOffsets.getBytes("utf-8");
            if (aesOffsets.length() > 16) {
                bytes = parseHexStr2Byte(aesOffsets);
            }
            IvParameterSpec iv = new IvParameterSpec(bytes);
            cipher.init(Cipher.DECRYPT_MODE, skeySpec, iv);
        } else {
            cipher = Cipher.getInstance("AES");
            cipher.init(Cipher.DECRYPT_MODE, skeySpec);
        }
        byte[] plainText = null;
        if (cipher != null) {
            plainText = cipher.doFinal(cipherText);
        }
        return plainText;
    }

    /**
     * 将16进制转换为二进制
     */
    public static byte[] parseHexStr2Byte(String hexStr) {
        if (hexStr.length() < 1)
            return null;
        byte[] result = new byte[hexStr.length() / 2];
        for (int i = 0; i < hexStr.length() / 2; i++) {
            int high = Integer.parseInt(hexStr.substring(i * 2, i * 2 + 1), 16);
            int low = Integer.parseInt(hexStr.substring(i * 2 + 1, i * 2 + 2),
                    16);
            result[i] = (byte) (high * 16 + low);
        }
        return result;
    }

    /**
     * zip解压缩
     *
     * @param compressType
     * @param dataArray
     * @return
     * @throws Exception
     */
    public static String unZipCompression(String compressType, byte[] dataArray)
            throws Exception {
        String xmlData = null;
        if (compressType != null && compressType.equals("0")) { // 无压缩
            try {
                xmlData = new String(dataArray, "utf-8");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        } else { // zip解压缩
            xmlData = unzipToString(dataArray);
        }
        return xmlData;
    }

    /**
     * 根据zip文件的字节数组，解析出zip文件中第一个压缩文件内容的字符串
     *
     * @param info
     * @return
     */
    public static String unzipToString(byte[] info) throws Exception {
        String strInfo = "";

        byte[] bytes = unzip(info);
        if (bytes != null) {
            try {
                strInfo = new String(bytes, "utf-8");
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        }

        return strInfo;
    }

    /**
     * 根据zip文件的字节数组，解析出zip文件中第一个压缩文件内容的字节数组
     *
     * @param info
     * @return
     */
    public static byte[] unzip(byte[] info) throws Exception {
        byte[] bytes = null;

        if (info != null) {
            ByteArrayOutputStream baos = new ByteArrayOutputStream();

            ZipInputStream in = new ZipInputStream(new ByteArrayInputStream(
                    info));
            ZipEntry z = null;
            if ((z = in.getNextEntry()) != null) {// zip中只有一个文件
                if (!z.isDirectory()) {
                    int len = -1;
                    byte data[] = new byte[1024];
                    while ((len = in.read(data)) != -1) {
                        baos.write(data, 0, len);
                    }
                }
            }
            baos.flush();
            bytes = baos.toByteArray();
        }

        return bytes;
    }


    /**
     * 读取gz文件
     *
     * @param fileName
     */
    public static void readFileByLines(String fileName) {
        GZIPInputStream gzipInputStream;
        BufferedReader reader = null;
        try {
            gzipInputStream = new GZIPInputStream(new FileInputStream(fileName));
            Reader decoder = new InputStreamReader(gzipInputStream, "UTF-8");
            reader = new BufferedReader(decoder);
            String tempString;
            //一次读一行，读入null时文件结束
            while ((tempString = reader.readLine()) != null) {
                //把当前行号显示出来
                System.out.println(tempString);
            }
            reader.close();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (reader != null) {
                try {
                    reader.close();
                } catch (IOException e1) {
                }
            }
        }
    }


    /**
     * 获取指定文件夹下所有文件，不含文件夹里的文件
     *
     * @param dirFilePath 文件夹路径
     * @return
     */
    public static List<File> getAllFile(String dirFilePath) {
        if (StrUtil.isBlank(dirFilePath))
            return null;
        return getAllFile(new File(dirFilePath));
    }


    /**
     * 获取指定文件夹下所有文件，不含文件夹里的文件
     *
     * @param dirFile 文件夹
     * @return
     */
    public static List<File> getAllFile(File dirFile) {
        // 如果文件夹不存在或着不是文件夹，则返回 null
        if (Objects.isNull(dirFile) || !dirFile.exists() || dirFile.isFile())
            return null;

        File[] childrenFiles = dirFile.listFiles();
        if (Objects.isNull(childrenFiles) || childrenFiles.length == 0)
            return null;

        List<File> files = new ArrayList<>();
        for (File childFile : childrenFiles) {
            // 如果是文件，直接添加到结果集合
            if (childFile.isFile()) {
                files.add(childFile);
            }
            //以下几行代码取消注释后可以将所有子文件夹里的文件也获取到列表里
//            else {
//                // 如果是文件夹，则将其内部文件添加进结果集合
//                List<File> cFiles = getAllFile(childFile);
//                if (Objects.isNull(cFiles) || cFiles.isEmpty()) continue;
//                files.addAll(cFiles);
//            }
        }
        return files;
    }


}
