package com.example.upsecuritydata.util;

import org.apache.commons.codec.binary.Base64;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.io.*;
import java.util.Date;
import java.util.Random;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

public class Encrypt {
	public static void main(String[] args) throws Exception {
		String readFile = "C:\\Users\\Reborn\\Desktop\\test.txt";

		File file = new File(readFile);
		BufferedReader br = new BufferedReader(new InputStreamReader(
				new FileInputStream(file)));
		StringBuilder sb = new StringBuilder();
		String line = null;
		while ((line = br.readLine()) != null) {
			sb.append(line).append("\n");
		}
		br.close();

		byte[] zip = zipToBytes("D:\\aaa", sb.toString());
		// dataUpload是压缩加密后的内容
		byte[] upload = encryptAlgorithm("1", zip, "1234567890abcDEF",
				"1234567890abcDEF");
		// 写文件
		FileOutputStream fos = new FileOutputStream(new File("d:\\aaa\\test.bin"));
		fos.write(upload);
		fos.close();

	}

	/**
	 * 将字符数组base64后转字符串
	 * 
	 * @param bArray
	 *            字符数组
	 * @return 字符转
	 */
	public static String getBaseByByte(byte[] bArray) {
		String str = null;
		bArray = Base64.encodeBase64(bArray);
		try {
			str = new String(bArray, "utf-8");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return str;
	}

	/**
	 * 将字符串压缩成zip文件并获得字节数据
	 * 
	 * @param path
	 * @param info
	 * @return
	 */
	public static byte[] zipToBytes(String path, String info) {
		String zipFileName = zip(path, info);
		byte[] zipBytes = getBytes(zipFileName);

		return zipBytes;
	}

	static AtomicInteger count = new AtomicInteger(0);

	/**
	 * 根据文件内容生成zip文件
	 * 
	 * @param path
	 * @param info
	 * @return
	 */
	public static String zip(String path, String info) {
		if (count.get() / 10000 == 0) {
			count.getAndSet(0);
		}
		int t = count.getAndIncrement();
		Long time = new Date().getTime();
		String commandId = String.valueOf(time & 0xffffffffl);
		// 添加4位随机数，ID重复问题。
		commandId = commandId + randomString(4);
		String filename = commandId + t;
		String zipFileName = path + "/" + filename + ".zip";
		if (info != null) {

			if (!checkDir(path)) {
				createDir(path);
			}

			File zipFile = new File(zipFileName);
			ZipOutputStream out = null;
			try {
				out = new ZipOutputStream(new FileOutputStream(zipFile));
				Date date = new Date();
				out.putNextEntry(new ZipEntry(date.getTime() + filename
						+ ".xml"));

				out.write(info.getBytes("utf-8"));
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				try {
					if (out != null) {
						out.flush();
						out.close();
					}
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}

		return zipFileName;
	}

	/**
	 * 对称加密
	 * 
	 * @param encryptType
	 *            加密类型
	 * @param zipxml
	 *            指令文件压缩后的结果
	 * @param aesKey
	 *            AES加密钥匙
	 * @param aesOffsets
	 *            AES加密偏移量
	 * @return
	 */
	public static byte[] encryptAlgorithm(String encryptType, byte[] zipxml,
			String aesKey, String aesOffsets) {
		byte[] command = null;

		if (encryptType != null && encryptType.equals("0")) { // 不加密
			command = zipxml;
		} else { // AES加密算法
			command = aes(zipxml, aesKey, aesOffsets);
		}
		return command;
	}

	/**
	 * 获得指定文件的byte数组
	 */
	public static byte[] getBytes(String filePath) {
		byte[] buffer = null;
		try {
			File file = new File(filePath);
			if (file.exists()) {
				FileInputStream fis = new FileInputStream(file);
				ByteArrayOutputStream bos = new ByteArrayOutputStream(1000);
				byte[] b = new byte[1000];
				int n;
				while ((n = fis.read(b)) != -1) {
					bos.write(b, 0, n);
				}
				fis.close();
				bos.close();
				buffer = bos.toByteArray();
			}
			file.delete();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return buffer;
	}

	/**
	 * aes加密
	 * 
	 * @param plainText
	 * @param aeskey
	 * @param aesOffsets
	 * @return
	 */
	public static byte[] aes(byte[] plainText, String aeskey, String aesOffsets) {
		try {
			byte[] aesBytes = aeskey.getBytes("utf-8");
			if (aeskey.length() > 16) {
				aesBytes = parseHexStr2Byte(aeskey);
				System.out.println(111);
			}
			SecretKeySpec skeySpec = new SecretKeySpec(aesBytes, "AES");
			Cipher cipher = null;
			if (aesOffsets != null && !(aesOffsets.trim()).equals("")) {
				cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
				byte[] bytes = aesOffsets.getBytes("utf-8");
				if (aesOffsets.length() > 16) {
					bytes = parseHexStr2Byte(aesOffsets);
				}
				IvParameterSpec iv = new IvParameterSpec(bytes);
				cipher.init(Cipher.ENCRYPT_MODE, skeySpec, iv);
			} else {
				cipher = Cipher.getInstance("AES");
				cipher.init(Cipher.ENCRYPT_MODE, skeySpec);
			}

			byte[] decryptText = null;
			if (cipher != null) {
				decryptText = cipher.doFinal(plainText);
			}
			return decryptText;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * 将16进制转换为二进制 　　
	 */
	public static byte[] parseHexStr2Byte(String hexStr) {
		if (hexStr.length() < 1)
			return null;
		byte[] result = new byte[hexStr.length() / 2];
		for (int i = 0; i < hexStr.length() / 2; i++) {
			int high = Integer.parseInt(hexStr.substring(i * 2, i * 2 + 1), 16);
			int low = Integer.parseInt(hexStr.substring(i * 2 + 1, i * 2 + 2),
					16);
			result[i] = (byte) (high * 16 + low);
		}
		return result;
	}

	// 生成n个字节的随机字符串
	public static String randomString(int length) {
		Random randGen = null;
		char[] numbersAndLetters = null;
		if (length < 1) {
			return null;
		}
		if (randGen == null) {
			randGen = new Random();
			numbersAndLetters = ("0123456789abcdefghijklmnopqrstuvwxyz"
					+ "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ").toCharArray();
			// numbersAndLetters =
			// ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ").toCharArray();
		}
		char[] randBuffer = new char[length];
		for (int i = 0; i < randBuffer.length; i++) {
			randBuffer[i] = numbersAndLetters[randGen.nextInt(71)];
			// randBuffer[i] = numbersAndLetters[randGen.nextInt(35)];
		}
		return new String(randBuffer);
	}

	/**
	 * 目录是否存在
	 * 
	 * @param dirName
	 * @return
	 */
	public static boolean checkDir(String dirName) {
		File dir = new File(dirName);
		if (dir.exists()) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * 创建目录
	 * 
	 * @param dirName
	 * @return
	 */
	public static boolean createDir(String dirName) {
		File dir = new File(dirName);

		if (!dirName.endsWith(File.separator)) {
			dirName = dirName + File.separator;
		}
		// 创建目录
		if (dir.mkdirs()) {
			System.out.println("创建目录" + dirName + "成功！");
			return true;
		} else {
			System.out.println("创建目录" + dirName + "失败！");
			return false;
		}
	}

}
